macroScript mcrLayers
	category:"Tools"
	toolTip:"Layers"
	buttonText:"Layers"
(
	--	known bugs:
	--	something undo related...

	global roLayersPos
	if roLayersPos==undefined then roLayersPos=[100,100]

	fn getObjProp o s ifNot:"" =
	(	--	gMax's getUserProp is broken, so...
		upb=filterString (getUserPropBuffer o) "\r\n"
		for kv in upb do
		(
			i=findString kv " = "
			if s == (subString kv 1 (i-1)) then
				return (subString kv (i+3) -1)
		)
		
		return ifNot
	)
	fn clearUserProp o l = 
	(
	--	format "fn clearObjectLayer % %\n" o.name l
		
		upb=filterString (getUserPropBuffer o) "\r\n"
		j=1
		while j<=upb.count do
		(
			kv=upb[j]
			i=findString kv " = "
			k=subString kv 1 (i-1)
	--		format "%:\t%\n" o.name k
			if l == k then
				deleteItem upb j
			else
				j+=1
		)
		newBuffer=""
		for kv in upb do newBuffer+=kv
		setUserPropBuffer o newBuffer
	)
	fn getObjectLayer o = getObjProp o "layer" ifNot:"(none)"
	fn setObjectLayer o l = 
		if l!="(none)" and l!="" then
			setUserProp o "layer" l
		else
			clearUserProp o "layer"


	fn fnObjectsByName o1 o2 =
	(
		n1=o1.name
		n2=o2.name
		if n1<n2 then return -1
		if n1>n2 then return 1
		return 0
	)
	fn sortObjectsByName layerMembers = qSort layerMembers fnObjectsByName


	global roInputStringDialogPos
	if roInputStringDialogPos==undefined then roInputStringDialogPos=[200,100]

	returnLayerName=""
	rollout roInputStringDialog "Layer name:" width:256
	(
		editText etInput "" across:2 width:200 height:18 align:#left
		button btOk "Ok" align:#right
		
		on etInput changed t do
		(
			i=findString (etInput.text) "\r\n"
			if i!=undefined then
			(
				t=replace (etInput.text) i 2 ""
				returnLayerName=t
				destroyDialog roInputStringDialog
			)
		)
		on btOk pressed do
		(
			returnLayerName=etInput.text
			destroyDialog roInputStringDialog
		)
		on roInputStringDialog open do
		(
			etInput.pos.x-=8
			btOk.pos.x+=8
			etInput.text=returnLayerName
		)
		
		on roInputStringDialog moved p do
			roInputStringDialogPos=getDialogPos roInputStringDialog
	)
	fn LayerNameDialog text:"" =
	(
		returnLayerName=text
		createDialog roInputStringDialog pos:roInputStringDialogPos modal:true
		return returnLayerName
	)

	if undefined != roLayers then
		if roLayers.open then
			destroyDialog roLayers

	rollout roLayers "Layers for gMax kinda" width:416 height:244
	(
		local layerNames = #()
		local layerMembers = #()
		local selectedMembers = #()
		
		--	rollout controls
		
		label lblLayers "Layers" pos:[9,7] width:31 height:13 across:2
		button btRefresh "refresh" pos:[109,7] width:48 height:14 toolTip:"Manually update lists"
		
		listbox lbLayers "" pos:[8,26] width:160 height:8
		
		dropdownList ddlSelect "" pos:[8,142] width:82 height:21 items:#("Selected", "UnSelected") across:2
		dropdownList ddlHide "" pos:[88,142] width:82 height:21 items:#("Hidden", "Visable")
		dropdownList ddlTrans "" pos:[8,169] width:82 height:21 items:#("Transparent", "Opaque") across:2
		dropdownList ddlFreeze "" pos:[88,169] width:82 height:21 items:#("Frozen", "Thawed")
		
		checkbutton cbOrganizeMode "Organize Mode" pos:[328,6] width:80 height:16 highlightColor:(color 255 0 0) toolTip:"When ative, selected members get assigned to selected layer"
		button btNewLayer "New Layer..." pos:[8,200] width:160 height:16 toolTip:"Assign selected members to a new layer"
		
		label lbMembers "..." pos:[176,8] width:144 height:13
		multiListBox mlbMembers "" pos:[176,24] width:232 height:16
		
		HyperLink hlPmBobbysoon "suggestions and bug reports" pos:[8,224] width:160 height:15 color:(color 127.5 127.5 127.5) hovercolor:(color 255 127.5 0) visitedcolor:(color 255 127.5 0) address:"http://forum.halomaps.org/index.cfm?page=privateMessageNew&messageTo=bobbysoon"
		
		--	functions
		
		fn ksjdfhg a b =
			case a of
			(
				0:			b
				undefined:	undefined
				true:		if b then b else undefined
				false:		if b then undefined else b
			)
		
		fn getSelectedLayerName = 
			if (i=lbLayers.selection)>0 then
				layerNames[i]
			else
				""
		
		fn setDDLState ddl state =
			if isKindOf state BooleanClass then
				ddl.selection=(if state then 1 else 2)
			else
				ddl.selection=0
		
		fn getMembersOfSelectedLayer =
		(
			saveRequired= getSaveRequired()
			
			layerName=getSelectedLayerName()
			layerMembers = #()
			
			s=h=t=f=0
			if layerName != "" then
				for o in objects where isValidNode o do
					if layerName == getObjectLayer o then
					(
						append layerMembers o
						
						s=ksjdfhg s o.isSelected
						h=ksjdfhg h o.isHidden
						t=ksjdfhg t o.xRay
						f=ksjdfhg f o.isFrozen
					)
			
			setDDLState ddlSelect s
			setDDLState ddlHide h
			setDDLState ddlTrans t
			setDDLState ddlFreeze f
			
			sortObjectsByName layerMembers
			
			lbMembers.caption="Members of "+layerName+": "+(layerMembers.count as string)
			mlbMembers.items = for o in layerMembers collect o.name
			mlbMembers.selection=#{}
			selectedMembers = #()
			btNewLayer.enabled=false
			
			setSaveRequired saveRequired
		)
		
		fn dghdjhdjhd ls l u =
			if ls==undefined or ls==0 then
				". ."
			else
				if ls then
					u
				else
					l
		
		fn getLayers = 
		(
			saveRequired= getSaveRequired()
			
			layerNames=#("(none)")
			layerObjectsCounts=#(0)
			layerStates=#(#(0,0,0,0))
			
			for o in objects where isValidNode o do
			(
				layerName = getObjectLayer o
				i=findItem layerNames layerName
				if 0==i then
				(
					append layerNames layerName
					append layerObjectsCounts 1
					append layerStates #(o.isSelected, o.isHidden, o.xRay, o.isFrozen)
				)
				else
				(
					ls=layerStates[i]
					
					ls[1] = ksjdfhg ls[1] o.isSelected
					ls[2] = ksjdfhg ls[2] o.isHidden
					ls[3] = ksjdfhg ls[3] o.xRay
					ls[4] = ksjdfhg ls[4] o.isFrozen
					
					layerObjectsCounts[i]+=1
				)
			)
			lbLayers.items = for i=1 to layerNames.count collect
			(
				ls1=dghdjhdjhd (layerStates[i])[1] "U" "S"
				ls2=dghdjhdjhd (layerStates[i])[2] "V" "H"
				ls3=dghdjhdjhd (layerStates[i])[3] "O" "T"
				ls4=dghdjhdjhd (layerStates[i])[4] "T" "F"
				ls=ls1+ls2+ls3+ls4
				ls+" "+layerNames[i]+": "+(layerObjectsCounts[i] as string)
			)
			
			getMembersOfSelectedLayer()
			
			setSaveRequired saveRequired
		)
		
		fn assignToLayer l =
		(
			lbLayers.enabled=false
			mlbMembers.enabled=false
			
			if selectedMembers.count>0 then
				for o in selectedMembers do setObjectLayer o l
			else
				for o in layerMembers do setObjectLayer o l
			
			lbLayers.enabled=true
			mlbMembers.enabled=true
		)
		
		fn setSelected sel state =
		(
			if state then
				selectMore sel
			else
				deSelect sel
			
		)
		
		fn itemAsBoolean state =
			if state==1 then
				true
			else if state==2 then
				false
			else
				undefined
		
		fn assignToLayerDialog text:"" =
		(
			l=LayerNameDialog text:text
			if l!="" then
			(
				assignToLayer l
				getLayers()
			)
		)
		
		--	rollout events
		
		on lbLayers selected i do
		(
			if cbOrganizeMode.state and selectedMembers.count>0 then
			(
				assignToLayer layerNames[i]
				getLayers()
			)
			else
				getMembersOfSelectedLayer()
		)
		
		on ddlSelect	selected state do
		(
			if selectedMembers.count==0 then
				setSelected layerMembers (itemAsBoolean state)
			else
				setSelected selectedMembers (itemAsBoolean state)
			getLayers()
		)
		on ddlHide		selected state do
		(
			if selectedMembers.count==0 then
				for o in layerMembers where isValidNode o do o.isHidden=(itemAsBoolean state)
			else
				for o in selectedMembers where isValidNode o do o.isHidden=(itemAsBoolean state)
			getLayers()
		)
		on ddlTrans		selected state do
		(
			if selectedMembers.count==0 then
				for o in layerMembers where isValidNode o do o.xRay=(itemAsBoolean state)
			else
				for o in selectedMembers where isValidNode o do o.xRay=(itemAsBoolean state)
			getLayers()
		)
		on ddlFreeze	selected state do
		(
			if selectedMembers.count==0 then
				for o in layerMembers where isValidNode o do o.isFrozen=(itemAsBoolean state)
			else
				for o in selectedMembers where isValidNode o do o.isFrozen=(itemAsBoolean state)
			getLayers()
		)
		
		on lbLayers doubleClicked i do
			if selectedMembers.count==0 then
				if i>1 then
					assignToLayerDialog text:(getSelectedLayerName())
		
		on btNewLayer pressed do assignToLayerDialog()
		
		on cbOrganizeMode changed state do
			btNewLayer.enabled=(selectedMembers.count>0) and state
		
		on mlbMembers selectionEnd do
		(
			lbLayers.enabled=false
			mlbMembers.enabled=false
			selectedMembers=for i in (mlbMembers.selection as array) collect
				layerMembers[i]
			
			clearListener()
			lbLayers.enabled=true
			mlbMembers.enabled=true
			btNewLayer.enabled=(selectedMembers.count>0) and cbOrganizeMode.state
		)
		
		on btRefresh pressed do getLayers()
		
		
		on roLayers open do	getLayers()
		on roLayers moved p do
			roLayersPos= getDialogPos roLayers
	)

	createDialog roLayers pos:roLayersPos

	setSaveRequired false
)
